               (* +--------------------------------+
                  |  Oprations sur les polynomes  |
                  +--------------------------------+ *)

#open "num";;
let zero = num_of_int 0
and un   = num_of_int 1
and deux = num_of_int 2;;


let simpl(p) =
  let lp = ref(vect_length(p)) in
  while (!lp > 0) && (p.(!lp-1) =/ zero) do lp := !lp-1 done;
  sub_vect p 0 !lp
;;

let somme p q =
  let lp = vect_length(p)    in
  let lq = vect_length(q)    in
  let lr = max lp lq         in
  let r  = make_vect lr zero in
  for i=0  to lp-1 do r.(i) <- p.(i)          done;
  for i=0  to lq-1 do r.(i) <- r.(i) +/ q.(i) done;
  simpl(r)
;;

let difference p q =
  let lp = vect_length(p)    in
  let lq = vect_length(q)    in
  let lr = max lp lq         in
  let r  = make_vect lr zero in
  for i=0  to lp-1 do r.(i) <- p.(i)          done;
  for i=0  to lq-1 do r.(i) <- r.(i) -/ q.(i) done;
  simpl(r)
;;

let p = map_vect num_of_int [| 1;2;3   |];;
let q = map_vect num_of_int [| 2;3;4;5 |];;
somme p q;;
difference p q;;
difference q q;;


let prod p q =
  let lp = vect_length(p)    in
  let lq = vect_length(q)    in
  let lr = max (lp+lq-1) 0   in
  let r  = make_vect lr zero in
  for i=0 to lp-1 do
    for j=0 to lq-1 do r.(i+j) <- r.(i+j) +/ p.(i)*/q.(j) done
  done;
  simpl(r)
;;

prod p q;;


let rec pp(n) =
  if      n = 0 then make_vect 0 zero
  else if n = 1 then [| zero; un//deux |]
  else begin
    let q  = pp(n-1)  in
    let q2 = prod q q in
    for i=0 to vect_length(q2)-1 do
      if i=1 then q2.(i) <- (un -/ q2.(i))//deux
             else q2.(i) <- (minus_num q2.(i))//deux
    done;
    somme q q2
  end
;;

pp(4);;


let diveucl a b =
  let la = vect_length(a)     in
  let lb = vect_length(b)     in
  let lq = max (la-lb+1) 0    in
  let lr = ref(la)            in
  let q  = make_vect lq  zero in
  let r  = make_vect !lr zero in

  for i=0  to la-1 do r.(i) <- a.(i) done;

  while !lr >= lb do
    let x = r.(!lr-1) // b.(lb-1) in
    q.(!lr-lb) <- x;
    for i=0 to lb-1 do r.(i+ !lr-lb) <- r.(i+ !lr-lb) -/ x*/b.(i) done;
    lr := !lr-1;
  done;

  (simpl(q),simpl(r))
;;

diveucl q p;;
diveucl p q;;
diveucl p (difference p p);;

let racine a =
  let la = vect_length(a)     in
  let lq = (la+1)/2           in
  let lr = ref(la-1)          in
  let q  = make_vect lq  zero in
  let r  = make_vect !lr zero in

  for i=0  to la-2 do r.(i) <- a.(i) done;
  q.(lq-1) <- un;

  while !lr >= lq do
    let x = r.(!lr-1) // deux in
    q.(!lr-lq) <- x;
    for i = !lr-lq+1 to lq-1 do r.(i+ !lr-lq) <- r.(i+ !lr-lq) -/ deux*/x*/q.(i) done;
    r.(2*(!lr-lq)) <- r.(2*(!lr-lq)) -/ x*/x;
    lr := !lr-1;
  done;

  (simpl(q),simpl(r))
;;

racine(map_vect num_of_int [| 1;2;3;4;5;6;1 |]);;


let rr(n) =
  let a = make_vect (2*n+1) zero in
  a.(2*n)   <- un;
  a.(2*n-1) <- un;
  let b,c = racine(a) in b
;;

rr(10);;
